import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkQrcode, ThinkQrcodeParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkQrcode(params: ThinkQrcodeParam) {
  const res = await request.get<ApiResult<PageResult<ThinkQrcode>>>(
    THINK_API_URL + '/think/think-qrcode/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkQrcode(params?: ThinkQrcodeParam) {
  const res = await request.get<ApiResult<ThinkQrcode[]>>(
    THINK_API_URL + '/think/think-qrcode',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkQrcode(data: ThinkQrcode) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-qrcode',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkQrcode(data: ThinkQrcode) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-qrcode',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkQrcode(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-qrcode/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkQrcode(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-qrcode/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkQrcode(id: number) {
  const res = await request.get<ApiResult<ThinkQrcode>>(
    THINK_API_URL + '/think/think-qrcode/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
